<?php

namespace backend\controllers;

use backend\models\MasterKompetensi;
use backend\models\MasterKompetensiSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * MasterKompetensiController implements the CRUD actions for MasterKompetensi model.
 */
class MasterKompetensiController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all MasterKompetensi models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $searchModel = new MasterKompetensiSearch();
        $dataProvider = $searchModel->search($this->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single MasterKompetensi model.
     * @param string $MASKOM_UUID Maskom Uuid
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($MASKOM_UUID)
    {
        return $this->render('view', [
            'model' => $this->findModel($MASKOM_UUID),
        ]);
    }

    /**
     * Creates a new MasterKompetensi model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new MasterKompetensi();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'MASKOM_UUID' => $model->MASKOM_UUID]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing MasterKompetensi model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param string $MASKOM_UUID Maskom Uuid
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($MASKOM_UUID)
    {
        $model = $this->findModel($MASKOM_UUID);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'MASKOM_UUID' => $model->MASKOM_UUID]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing MasterKompetensi model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param string $MASKOM_UUID Maskom Uuid
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($MASKOM_UUID)
    {
        $this->findModel($MASKOM_UUID)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the MasterKompetensi model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param string $MASKOM_UUID Maskom Uuid
     * @return MasterKompetensi the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($MASKOM_UUID)
    {
        if (($model = MasterKompetensi::findOne(['MASKOM_UUID' => $MASKOM_UUID])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}
